Index: XIOS/trunk/src/interface/fortran_attr/idomain_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/idomain_attr.F90	(revision 611)
+++ XIOS/trunk/src/interface/fortran_attr/idomain_attr.F90	(revision 657)
@@ -14,7 +14,6 @@
     ( domain_id, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
     , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+    , standard_name, type )
 
     IMPLICIT NONE
@@ -34,10 +33,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref
-      INTEGER  , OPTIONAL, INTENT(IN) :: i_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: i_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: ibegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: iend
-      INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: jend
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue(:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: long_name
@@ -53,12 +50,4 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ibegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ibegin_loc
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_jbegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_jbegin_loc
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ni
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ni_loc
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_nj
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_nj_loc
 
       CALL xios(get_domain_handle)(domain_id,domain_hdl)
@@ -66,7 +55,6 @@
       ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
       , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+      , standard_name, type )
 
   END SUBROUTINE xios(set_domain_attr)
@@ -75,7 +63,6 @@
     ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
     , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+    , standard_name, type )
 
     IMPLICIT NONE
@@ -94,10 +81,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref
-      INTEGER  , OPTIONAL, INTENT(IN) :: i_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: i_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: ibegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: iend
-      INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: jend
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue(:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: long_name
@@ -113,19 +98,10 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ibegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ibegin_loc
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_jbegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_jbegin_loc
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ni
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ni_loc
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_nj
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_nj_loc
 
       CALL xios(set_domain_attr_hdl_)  &
       ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
       , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+      , standard_name, type )
 
   END SUBROUTINE xios(set_domain_attr_hdl)
@@ -134,7 +110,6 @@
     ( domain_hdl, area_, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
     , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, domain_ref_, i_index_  &
-    , ibegin_, iend_, j_index_, jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_  &
-    , ni_glo_, nj_, nj_glo_, nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_  &
-    , zoom_jbegin_loc_, zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
+    , ibegin_, j_index_, jbegin_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_  &
+    , nj_glo_, nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
@@ -153,10 +128,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref_
-      INTEGER  , OPTIONAL, INTENT(IN) :: i_index_(:,:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: i_index_(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: ibegin_
-      INTEGER  , OPTIONAL, INTENT(IN) :: iend_
-      INTEGER  , OPTIONAL, INTENT(IN) :: j_index_(:,:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: j_index_(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin_
-      INTEGER  , OPTIONAL, INTENT(IN) :: jend_
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_(:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: long_name_
@@ -172,12 +145,4 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ibegin_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ibegin_loc_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_jbegin_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_jbegin_loc_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ni_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_ni_loc_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_nj_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_nj_loc_
 
       IF (PRESENT(area_)) THEN
@@ -234,5 +199,5 @@
 
       IF (PRESENT(i_index_)) THEN
-        CALL cxios_set_domain_i_index(domain_hdl%daddr, i_index_, size(i_index_,1), size(i_index_,2))
+        CALL cxios_set_domain_i_index(domain_hdl%daddr, i_index_, size(i_index_,1))
       ENDIF
 
@@ -241,18 +206,10 @@
       ENDIF
 
-      IF (PRESENT(iend_)) THEN
-        CALL cxios_set_domain_iend(domain_hdl%daddr, iend_)
-      ENDIF
-
       IF (PRESENT(j_index_)) THEN
-        CALL cxios_set_domain_j_index(domain_hdl%daddr, j_index_, size(j_index_,1), size(j_index_,2))
+        CALL cxios_set_domain_j_index(domain_hdl%daddr, j_index_, size(j_index_,1))
       ENDIF
 
       IF (PRESENT(jbegin_)) THEN
         CALL cxios_set_domain_jbegin(domain_hdl%daddr, jbegin_)
-      ENDIF
-
-      IF (PRESENT(jend_)) THEN
-        CALL cxios_set_domain_jend(domain_hdl%daddr, jend_)
       ENDIF
 
@@ -307,36 +264,4 @@
       ENDIF
 
-      IF (PRESENT(zoom_ibegin_)) THEN
-        CALL cxios_set_domain_zoom_ibegin(domain_hdl%daddr, zoom_ibegin_)
-      ENDIF
-
-      IF (PRESENT(zoom_ibegin_loc_)) THEN
-        CALL cxios_set_domain_zoom_ibegin_loc(domain_hdl%daddr, zoom_ibegin_loc_)
-      ENDIF
-
-      IF (PRESENT(zoom_jbegin_)) THEN
-        CALL cxios_set_domain_zoom_jbegin(domain_hdl%daddr, zoom_jbegin_)
-      ENDIF
-
-      IF (PRESENT(zoom_jbegin_loc_)) THEN
-        CALL cxios_set_domain_zoom_jbegin_loc(domain_hdl%daddr, zoom_jbegin_loc_)
-      ENDIF
-
-      IF (PRESENT(zoom_ni_)) THEN
-        CALL cxios_set_domain_zoom_ni(domain_hdl%daddr, zoom_ni_)
-      ENDIF
-
-      IF (PRESENT(zoom_ni_loc_)) THEN
-        CALL cxios_set_domain_zoom_ni_loc(domain_hdl%daddr, zoom_ni_loc_)
-      ENDIF
-
-      IF (PRESENT(zoom_nj_)) THEN
-        CALL cxios_set_domain_zoom_nj(domain_hdl%daddr, zoom_nj_)
-      ENDIF
-
-      IF (PRESENT(zoom_nj_loc_)) THEN
-        CALL cxios_set_domain_zoom_nj_loc(domain_hdl%daddr, zoom_nj_loc_)
-      ENDIF
-
   END SUBROUTINE xios(set_domain_attr_hdl_)
 
@@ -344,7 +269,6 @@
     ( domain_id, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
     , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+    , standard_name, type )
 
     IMPLICIT NONE
@@ -364,10 +288,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref
-      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: ibegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: iend
-      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: jend
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue(:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: long_name
@@ -383,12 +305,4 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ibegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_jbegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ni
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ni_loc
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_nj
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_nj_loc
 
       CALL xios(get_domain_handle)(domain_id,domain_hdl)
@@ -396,7 +310,6 @@
       ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
       , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+      , standard_name, type )
 
   END SUBROUTINE xios(get_domain_attr)
@@ -405,7 +318,6 @@
     ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
     , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+    , standard_name, type )
 
     IMPLICIT NONE
@@ -424,10 +336,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref
-      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: ibegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: iend
-      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:,:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: jend
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue(:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: long_name
@@ -443,19 +353,10 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ibegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_jbegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ni
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ni_loc
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_nj
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_nj_loc
 
       CALL xios(get_domain_attr_hdl_)  &
       ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
       , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+      , standard_name, type )
 
   END SUBROUTINE xios(get_domain_attr_hdl)
@@ -464,7 +365,6 @@
     ( domain_hdl, area_, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
     , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, domain_ref_, i_index_  &
-    , ibegin_, iend_, j_index_, jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_  &
-    , ni_glo_, nj_, nj_glo_, nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_  &
-    , zoom_jbegin_loc_, zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
+    , ibegin_, j_index_, jbegin_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_  &
+    , nj_glo_, nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
@@ -483,10 +383,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index_(:,:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index_(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: ibegin_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: iend_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index_(:,:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index_(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: jend_
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_(:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: long_name_
@@ -502,12 +400,4 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ibegin_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_jbegin_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ni_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_ni_loc_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_nj_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_nj_loc_
 
       IF (PRESENT(area_)) THEN
@@ -564,5 +454,5 @@
 
       IF (PRESENT(i_index_)) THEN
-        CALL cxios_get_domain_i_index(domain_hdl%daddr, i_index_, size(i_index_,1), size(i_index_,2))
+        CALL cxios_get_domain_i_index(domain_hdl%daddr, i_index_, size(i_index_,1))
       ENDIF
 
@@ -571,18 +461,10 @@
       ENDIF
 
-      IF (PRESENT(iend_)) THEN
-        CALL cxios_get_domain_iend(domain_hdl%daddr, iend_)
-      ENDIF
-
       IF (PRESENT(j_index_)) THEN
-        CALL cxios_get_domain_j_index(domain_hdl%daddr, j_index_, size(j_index_,1), size(j_index_,2))
+        CALL cxios_get_domain_j_index(domain_hdl%daddr, j_index_, size(j_index_,1))
       ENDIF
 
       IF (PRESENT(jbegin_)) THEN
         CALL cxios_get_domain_jbegin(domain_hdl%daddr, jbegin_)
-      ENDIF
-
-      IF (PRESENT(jend_)) THEN
-        CALL cxios_get_domain_jend(domain_hdl%daddr, jend_)
       ENDIF
 
@@ -637,36 +519,4 @@
       ENDIF
 
-      IF (PRESENT(zoom_ibegin_)) THEN
-        CALL cxios_get_domain_zoom_ibegin(domain_hdl%daddr, zoom_ibegin_)
-      ENDIF
-
-      IF (PRESENT(zoom_ibegin_loc_)) THEN
-        CALL cxios_get_domain_zoom_ibegin_loc(domain_hdl%daddr, zoom_ibegin_loc_)
-      ENDIF
-
-      IF (PRESENT(zoom_jbegin_)) THEN
-        CALL cxios_get_domain_zoom_jbegin(domain_hdl%daddr, zoom_jbegin_)
-      ENDIF
-
-      IF (PRESENT(zoom_jbegin_loc_)) THEN
-        CALL cxios_get_domain_zoom_jbegin_loc(domain_hdl%daddr, zoom_jbegin_loc_)
-      ENDIF
-
-      IF (PRESENT(zoom_ni_)) THEN
-        CALL cxios_get_domain_zoom_ni(domain_hdl%daddr, zoom_ni_)
-      ENDIF
-
-      IF (PRESENT(zoom_ni_loc_)) THEN
-        CALL cxios_get_domain_zoom_ni_loc(domain_hdl%daddr, zoom_ni_loc_)
-      ENDIF
-
-      IF (PRESENT(zoom_nj_)) THEN
-        CALL cxios_get_domain_zoom_nj(domain_hdl%daddr, zoom_nj_)
-      ENDIF
-
-      IF (PRESENT(zoom_nj_loc_)) THEN
-        CALL cxios_get_domain_zoom_nj_loc(domain_hdl%daddr, zoom_nj_loc_)
-      ENDIF
-
   END SUBROUTINE xios(get_domain_attr_hdl_)
 
@@ -674,7 +524,6 @@
     ( domain_id, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
     , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+    , standard_name, type )
 
     IMPLICIT NONE
@@ -711,12 +560,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin
       LOGICAL(KIND=C_BOOL) :: ibegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: iend
-      LOGICAL(KIND=C_BOOL) :: iend_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: j_index
       LOGICAL(KIND=C_BOOL) :: j_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
       LOGICAL(KIND=C_BOOL) :: jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: jend
-      LOGICAL(KIND=C_BOOL) :: jend_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue
       LOGICAL(KIND=C_BOOL) :: latvalue_tmp
@@ -743,20 +588,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin
-      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_loc_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin
-      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_loc_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni
-      LOGICAL(KIND=C_BOOL) :: zoom_ni_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_ni_loc_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj
-      LOGICAL(KIND=C_BOOL) :: zoom_nj_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_nj_loc_tmp
 
       CALL xios(get_domain_handle)(domain_id,domain_hdl)
@@ -764,7 +593,6 @@
       ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
       , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+      , standard_name, type )
 
   END SUBROUTINE xios(is_defined_domain_attr)
@@ -773,7 +601,6 @@
     ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
     , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+    , standard_name, type )
 
     IMPLICIT NONE
@@ -809,12 +636,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin
       LOGICAL(KIND=C_BOOL) :: ibegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: iend
-      LOGICAL(KIND=C_BOOL) :: iend_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: j_index
       LOGICAL(KIND=C_BOOL) :: j_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
       LOGICAL(KIND=C_BOOL) :: jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: jend
-      LOGICAL(KIND=C_BOOL) :: jend_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue
       LOGICAL(KIND=C_BOOL) :: latvalue_tmp
@@ -841,27 +664,10 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin
-      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_loc_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin
-      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_loc_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni
-      LOGICAL(KIND=C_BOOL) :: zoom_ni_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_ni_loc_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj
-      LOGICAL(KIND=C_BOOL) :: zoom_nj_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_loc
-      LOGICAL(KIND=C_BOOL) :: zoom_nj_loc_tmp
 
       CALL xios(is_defined_domain_attr_hdl_)  &
       ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
       , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
-      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
-      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
+      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
+      , standard_name, type )
 
   END SUBROUTINE xios(is_defined_domain_attr_hdl)
@@ -870,7 +676,6 @@
     ( domain_hdl, area_, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
     , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, domain_ref_, i_index_  &
-    , ibegin_, iend_, j_index_, jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_  &
-    , ni_glo_, nj_, nj_glo_, nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_  &
-    , zoom_jbegin_loc_, zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
+    , ibegin_, j_index_, jbegin_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_  &
+    , nj_glo_, nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
@@ -906,12 +711,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin_
       LOGICAL(KIND=C_BOOL) :: ibegin__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: iend_
-      LOGICAL(KIND=C_BOOL) :: iend__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: j_index_
       LOGICAL(KIND=C_BOOL) :: j_index__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin_
       LOGICAL(KIND=C_BOOL) :: jbegin__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: jend_
-      LOGICAL(KIND=C_BOOL) :: jend__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue_
       LOGICAL(KIND=C_BOOL) :: latvalue__tmp
@@ -938,20 +739,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: type_
       LOGICAL(KIND=C_BOOL) :: type__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_
-      LOGICAL(KIND=C_BOOL) :: zoom_ibegin__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc_
-      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_loc__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_
-      LOGICAL(KIND=C_BOOL) :: zoom_jbegin__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc_
-      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_loc__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_
-      LOGICAL(KIND=C_BOOL) :: zoom_ni__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_loc_
-      LOGICAL(KIND=C_BOOL) :: zoom_ni_loc__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_
-      LOGICAL(KIND=C_BOOL) :: zoom_nj__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_loc_
-      LOGICAL(KIND=C_BOOL) :: zoom_nj_loc__tmp
 
       IF (PRESENT(area_)) THEN
@@ -1030,9 +815,4 @@
       ENDIF
 
-      IF (PRESENT(iend_)) THEN
-        iend__tmp = cxios_is_defined_domain_iend(domain_hdl%daddr)
-        iend_ = iend__tmp
-      ENDIF
-
       IF (PRESENT(j_index_)) THEN
         j_index__tmp = cxios_is_defined_domain_j_index(domain_hdl%daddr)
@@ -1045,9 +825,4 @@
       ENDIF
 
-      IF (PRESENT(jend_)) THEN
-        jend__tmp = cxios_is_defined_domain_jend(domain_hdl%daddr)
-        jend_ = jend__tmp
-      ENDIF
-
       IF (PRESENT(latvalue_)) THEN
         latvalue__tmp = cxios_is_defined_domain_latvalue(domain_hdl%daddr)
@@ -1110,44 +885,4 @@
       ENDIF
 
-      IF (PRESENT(zoom_ibegin_)) THEN
-        zoom_ibegin__tmp = cxios_is_defined_domain_zoom_ibegin(domain_hdl%daddr)
-        zoom_ibegin_ = zoom_ibegin__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_ibegin_loc_)) THEN
-        zoom_ibegin_loc__tmp = cxios_is_defined_domain_zoom_ibegin_loc(domain_hdl%daddr)
-        zoom_ibegin_loc_ = zoom_ibegin_loc__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_jbegin_)) THEN
-        zoom_jbegin__tmp = cxios_is_defined_domain_zoom_jbegin(domain_hdl%daddr)
-        zoom_jbegin_ = zoom_jbegin__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_jbegin_loc_)) THEN
-        zoom_jbegin_loc__tmp = cxios_is_defined_domain_zoom_jbegin_loc(domain_hdl%daddr)
-        zoom_jbegin_loc_ = zoom_jbegin_loc__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_ni_)) THEN
-        zoom_ni__tmp = cxios_is_defined_domain_zoom_ni(domain_hdl%daddr)
-        zoom_ni_ = zoom_ni__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_ni_loc_)) THEN
-        zoom_ni_loc__tmp = cxios_is_defined_domain_zoom_ni_loc(domain_hdl%daddr)
-        zoom_ni_loc_ = zoom_ni_loc__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_nj_)) THEN
-        zoom_nj__tmp = cxios_is_defined_domain_zoom_nj(domain_hdl%daddr)
-        zoom_nj_ = zoom_nj__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_nj_loc_)) THEN
-        zoom_nj_loc__tmp = cxios_is_defined_domain_zoom_nj_loc(domain_hdl%daddr)
-        zoom_nj_loc_ = zoom_nj_loc__tmp
-      ENDIF
-
   END SUBROUTINE xios(is_defined_domain_attr_hdl_)
 